import json
from typing import List

class UserCluster:
    def __init__(self, cluster_label: int, clusters: List):
        super().__init__()
        self.cluster_label = cluster_label
        self.clusters = clusters
        self.id = f'{self.cluster_label}'

    def to_serializable_dict(self, for_db=False):
        return {
            "id": self.id,
            "cluster_label": self.cluster_label,
            "clusters": json.dumps(self.clusters) if for_db else self.clusters
        }

    def __repr__(self):
        return json.dumps(self.to_serializable_dict())

    def __str__(self):
        return f"UserCluster({self.__repr__()})"
